/*
 * Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package javafx.scene.control;

/**
Builder class for javafx.scene.control.SplitPane
@see javafx.scene.control.SplitPane
@deprecated This class is deprecated and will be removed in the next version
* @since JavaFX 2.0
*/
@javax.annotation.Generated("Generated by javafx.builder.processor.BuilderProcessor")
@Deprecated
public class SplitPaneBuilder<B extends javafx.scene.control.SplitPaneBuilder<B>> extends javafx.scene.control.ControlBuilder<B> implements javafx.util.Builder<javafx.scene.control.SplitPane> {
    protected SplitPaneBuilder() {
    }

    /** Creates a new instance of SplitPaneBuilder. */
    @SuppressWarnings({"deprecation", "rawtypes", "unchecked"})
    public static javafx.scene.control.SplitPaneBuilder<?> create() {
        return new javafx.scene.control.SplitPaneBuilder();
    }

    private int __set;
    public void applyTo(javafx.scene.control.SplitPane x) {
        super.applyTo(x);
        int set = __set;
        if ((set & (1 << 0)) != 0) x.setDividerPositions(this.dividerPositions);
        if ((set & (1 << 1)) != 0) x.getItems().addAll(this.items);
        if ((set & (1 << 2)) != 0) x.setOrientation(this.orientation);
    }

    private double[] dividerPositions;
    /**
    Set the value of the {@link javafx.scene.control.SplitPane#getDividerPositions() dividerPositions} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B dividerPositions(double[] x) {
        this.dividerPositions = x;
        __set |= 1 << 0;
        return (B) this;
    }

    private java.util.Collection<? extends javafx.scene.Node> items;
    /**
    Add the given items to the List of items in the {@link javafx.scene.control.SplitPane#getItems() items} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B items(java.util.Collection<? extends javafx.scene.Node> x) {
        this.items = x;
        __set |= 1 << 1;
        return (B) this;
    }

    /**
    Add the given items to the List of items in the {@link javafx.scene.control.SplitPane#getItems() items} property for the instance constructed by this builder.
    */
    public B items(javafx.scene.Node... x) {
        return items(java.util.Arrays.asList(x));
    }

    private javafx.geometry.Orientation orientation;
    /**
    Set the value of the {@link javafx.scene.control.SplitPane#getOrientation() orientation} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B orientation(javafx.geometry.Orientation x) {
        this.orientation = x;
        __set |= 1 << 2;
        return (B) this;
    }

    /**
    Make an instance of {@link javafx.scene.control.SplitPane} based on the properties set on this builder.
    */
    public javafx.scene.control.SplitPane build() {
        javafx.scene.control.SplitPane x = new javafx.scene.control.SplitPane();
        applyTo(x);
        return x;
    }
}
