/*
 * Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package javafx.scene.shape;

/**
Builder class for javafx.scene.shape.Rectangle
@see javafx.scene.shape.Rectangle
@deprecated This class is deprecated and will be removed in the next version
* @since JavaFX 2.0
*/
@javax.annotation.Generated("Generated by javafx.builder.processor.BuilderProcessor")
@Deprecated
public class RectangleBuilder<B extends javafx.scene.shape.RectangleBuilder<B>> extends javafx.scene.shape.ShapeBuilder<B> implements javafx.util.Builder<javafx.scene.shape.Rectangle> {
    protected RectangleBuilder() {
    }

    /** Creates a new instance of RectangleBuilder. */
    @SuppressWarnings({"deprecation", "rawtypes", "unchecked"})
    public static javafx.scene.shape.RectangleBuilder<?> create() {
        return new javafx.scene.shape.RectangleBuilder();
    }

    private int __set;
    public void applyTo(javafx.scene.shape.Rectangle x) {
        super.applyTo(x);
        int set = __set;
        if ((set & (1 << 0)) != 0) x.setArcHeight(this.arcHeight);
        if ((set & (1 << 1)) != 0) x.setArcWidth(this.arcWidth);
        if ((set & (1 << 2)) != 0) x.setHeight(this.height);
        if ((set & (1 << 3)) != 0) x.setWidth(this.width);
        if ((set & (1 << 4)) != 0) x.setX(this.x);
        if ((set & (1 << 5)) != 0) x.setY(this.y);
    }

    private double arcHeight;
    /**
    Set the value of the {@link javafx.scene.shape.Rectangle#getArcHeight() arcHeight} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B arcHeight(double x) {
        this.arcHeight = x;
        __set |= 1 << 0;
        return (B) this;
    }

    private double arcWidth;
    /**
    Set the value of the {@link javafx.scene.shape.Rectangle#getArcWidth() arcWidth} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B arcWidth(double x) {
        this.arcWidth = x;
        __set |= 1 << 1;
        return (B) this;
    }

    private double height;
    /**
    Set the value of the {@link javafx.scene.shape.Rectangle#getHeight() height} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B height(double x) {
        this.height = x;
        __set |= 1 << 2;
        return (B) this;
    }

    private double width;
    /**
    Set the value of the {@link javafx.scene.shape.Rectangle#getWidth() width} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B width(double x) {
        this.width = x;
        __set |= 1 << 3;
        return (B) this;
    }

    private double x;
    /**
    Set the value of the {@link javafx.scene.shape.Rectangle#getX() x} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B x(double x) {
        this.x = x;
        __set |= 1 << 4;
        return (B) this;
    }

    private double y;
    /**
    Set the value of the {@link javafx.scene.shape.Rectangle#getY() y} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B y(double x) {
        this.y = x;
        __set |= 1 << 5;
        return (B) this;
    }

    /**
    Make an instance of {@link javafx.scene.shape.Rectangle} based on the properties set on this builder.
    */
    public javafx.scene.shape.Rectangle build() {
        javafx.scene.shape.Rectangle x = new javafx.scene.shape.Rectangle();
        applyTo(x);
        return x;
    }
}
